;************************
;knihovna pre pracu s I2C
;************************
	
	.EQU SCL=1		;signaly
	.EQU SDA=0		;I2C
	
	.EQU I2CPO=PORTB	
	.EQU I2CDD=DDRB	;port D
	.EQU I2CPI=PINB	;
	
	.DEF I2CACC=R16	;REG0 
	.DEF I2CCT1=R17	;REG1 
	.DEF I2CCT2=R18	;REG2 
	
	;nastavi urceny vodic I2C:
	.MACRO I2CSET	
	SBI I2CPO,@0	;pull-up
	CBI I2CDD,@0	;vstup
	.ENDMACRO	
	
	;nuluje urceny vodiv I2C:
	.MACRO I2CCLR	
	CBI I2CPO,@0	;log. 0
	SBI I2CDD,@0	;vstup
	.ENDMACRO	
	
;vysle START
I2CSTA:	I2CSET SDA	;SDA=1
		I2CSET SCL	;SCL=1
		RCALL I2CCEK
		I2CCLR SDA	;SCL=1, SDA=0
		RCALL I2CCEK
		I2CCLR SCL	;SCL=0, SDA=0
		RCALL I2CCEK
		RET	
		
;vysle STOP:
I2CSTP:	RCALL I2CCEK	
		I2CCLR SDA		;SDA=0
		RCALL I2CCEK	
		I2CSET SCL		;SCL=1,SDA=0
		RCALL I2CCEK	
		I2CSET SDA		;SCL=1,SDA=1
		RET	

		
;posle obsah I2CACC
;vstup: I2CACC - hodnota pre vysielanie
;vstup: C-stav ACK
;poznamka: I2CACC se po volani nezmeni
I2CPSL:	LDI I2CCT2,8	;8 bitov
I2CPSM:	ROL I2CACC		;horny bit do C
		BRCC I2CPS0	
		I2CSET SDA		;SDA=C pre C=1
		RJMP I2CPS1	
I2CPS0:	I2CCLR SDA		;SDA=C pre C=0
I2CPS1:	RCALL I2CCEK	
		I2CSET SCL		;SCL=1
		RCALL I2CCEK	
		I2CCLR SCL		;SCL=0
		DEC I2CCT2		;dekrementuj pocitadlo
		BRNE I2CPSM		;koniec?
		RCALL I2CCEK	
		I2CSET SDA		;priprava na ACK
		RCALL I2CCEK	
		I2CSET SCL		;SCL=1
		RCALL I2CCEK	
		SEC				;C=1
		SBIS I2CPI,SDA	;pre SDA=1 preskoc
		CLC				;C=0
		I2CCLR SCL		;SCL=0
		ROL I2CACC		;obnov I2CACC
		RET	
I2CCEK:	LDI I2CCT1,50 	;asi 15ms
I2CCCK:	DEC I2CCT1	
		BRNE I2CCCK	
		RET	
		
;ita do I2CACC
;vstup: I2CACC-precitana hodnota

I2CCTI:	I2CSET SDA		;SDA pull-up
		LDI I2CCT2,8	;8 bitov
I2CCTS:	RCALL I2CCEK	
		I2CSET SCL		;SCL=1
		RCALL I2CCEK	
		SEC				;C=1
		SBIS I2CPI,SDA	;pre SDA=1 preskoc
		CLC				;C=0
		ROL I2CACC		;vsun do I2CACC
		I2CCLR SCL		;SCL=0
		RCALL I2CCEK	
		DEC I2CCT2		;deekrementuj pocitadlo
		BRNE I2CCTS		;koniec?
		RET

;cita s ack 1
I2CCTIA1:	RCALL I2CCTI	
		 	I2CSET	SDA		;SDA=1
		 	RCALL I2CCEK	
		 	I2CSET	SCL		;SCL=1
		 	RCALL I2CCEK	
		 	I2CCLR	SCL		;SCL=0
			RET
			
;cita s ack 0 			
I2CCTIA0:	RCALL I2CCTI
			I2CCLR	SDA		;SDA=1
			RCALL I2CCEK
			I2CSET	SCL		;SCL=1
			RCALL I2CCEK
			I2CCLR	SCL		;SCL=0
	    	RET
		
						